/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-robocup-msgs-0.0.7/msg/Bearing.msg
 *
 */


#ifndef ROBOCUP_MSGS_MESSAGE_BEARING_H
#define ROBOCUP_MSGS_MESSAGE_BEARING_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace robocup_msgs
{
template <class ContainerAllocator>
struct Bearing_
{
  typedef Bearing_<ContainerAllocator> Type;

  Bearing_()
    : distance(0.0)
    , angle1(0.0)
    , angle2(0.0)  {
    }
  Bearing_(const ContainerAllocator& _alloc)
    : distance(0.0)
    , angle1(0.0)
    , angle2(0.0)  {
    }



   typedef float _distance_type;
  _distance_type distance;

   typedef float _angle1_type;
  _angle1_type angle1;

   typedef float _angle2_type;
  _angle2_type angle2;




  typedef boost::shared_ptr< ::robocup_msgs::Bearing_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::robocup_msgs::Bearing_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Bearing_

typedef ::robocup_msgs::Bearing_<std::allocator<void> > Bearing;

typedef boost::shared_ptr< ::robocup_msgs::Bearing > BearingPtr;
typedef boost::shared_ptr< ::robocup_msgs::Bearing const> BearingConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::robocup_msgs::Bearing_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::robocup_msgs::Bearing_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace robocup_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/hydro/share/trajectory_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'robocup_msgs': ['/tmp/buildd/ros-hydro-robocup-msgs-0.0.7/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::robocup_msgs::Bearing_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::robocup_msgs::Bearing_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::robocup_msgs::Bearing_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::robocup_msgs::Bearing_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::robocup_msgs::Bearing_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::robocup_msgs::Bearing_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::robocup_msgs::Bearing_<ContainerAllocator> >
{
  static const char* value()
  {
    return "2744fe920d7cdbb6701152946f1ba8da";
  }

  static const char* value(const ::robocup_msgs::Bearing_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x2744fe920d7cdbb6ULL;
  static const uint64_t static_value2 = 0x701152946f1ba8daULL;
};

template<class ContainerAllocator>
struct DataType< ::robocup_msgs::Bearing_<ContainerAllocator> >
{
  static const char* value()
  {
    return "robocup_msgs/Bearing";
  }

  static const char* value(const ::robocup_msgs::Bearing_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::robocup_msgs::Bearing_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# A message for simulated visual sensing\n\
\n\
float32 distance\n\
float32 angle1\n\
float32 angle2\n\
";
  }

  static const char* value(const ::robocup_msgs::Bearing_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::robocup_msgs::Bearing_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.distance);
      stream.next(m.angle1);
      stream.next(m.angle2);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Bearing_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::robocup_msgs::Bearing_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::robocup_msgs::Bearing_<ContainerAllocator>& v)
  {
    s << indent << "distance: ";
    Printer<float>::stream(s, indent + "  ", v.distance);
    s << indent << "angle1: ";
    Printer<float>::stream(s, indent + "  ", v.angle1);
    s << indent << "angle2: ";
    Printer<float>::stream(s, indent + "  ", v.angle2);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ROBOCUP_MSGS_MESSAGE_BEARING_H
