/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-robocup-msgs-0.0.7/msg/Hear.msg
 *
 */


#ifndef ROBOCUP_MSGS_MESSAGE_HEAR_H
#define ROBOCUP_MSGS_MESSAGE_HEAR_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <geometry_msgs/Quaternion.h>

namespace robocup_msgs
{
template <class ContainerAllocator>
struct Hear_
{
  typedef Hear_<ContainerAllocator> Type;

  Hear_()
    : time()
    , direction()
    , message()  {
      message.assign(0);
  }
  Hear_(const ContainerAllocator& _alloc)
    : time()
    , direction(_alloc)
    , message()  {
      message.assign(0);
  }



   typedef ros::Time _time_type;
  _time_type time;

   typedef  ::geometry_msgs::Quaternion_<ContainerAllocator>  _direction_type;
  _direction_type direction;

   typedef boost::array<uint8_t, 20>  _message_type;
  _message_type message;




  typedef boost::shared_ptr< ::robocup_msgs::Hear_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::robocup_msgs::Hear_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Hear_

typedef ::robocup_msgs::Hear_<std::allocator<void> > Hear;

typedef boost::shared_ptr< ::robocup_msgs::Hear > HearPtr;
typedef boost::shared_ptr< ::robocup_msgs::Hear const> HearConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::robocup_msgs::Hear_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::robocup_msgs::Hear_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace robocup_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/hydro/share/trajectory_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'robocup_msgs': ['/tmp/buildd/ros-hydro-robocup-msgs-0.0.7/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::robocup_msgs::Hear_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::robocup_msgs::Hear_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::robocup_msgs::Hear_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::robocup_msgs::Hear_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::robocup_msgs::Hear_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::robocup_msgs::Hear_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::robocup_msgs::Hear_<ContainerAllocator> >
{
  static const char* value()
  {
    return "72f71b51e6202b5b12af15a486bd6cae";
  }

  static const char* value(const ::robocup_msgs::Hear_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x72f71b51e6202b5bULL;
  static const uint64_t static_value2 = 0x12af15a486bd6caeULL;
};

template<class ContainerAllocator>
struct DataType< ::robocup_msgs::Hear_<ContainerAllocator> >
{
  static const char* value()
  {
    return "robocup_msgs/Hear";
  }

  static const char* value(const ::robocup_msgs::Hear_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::robocup_msgs::Hear_<ContainerAllocator> >
{
  static const char* value()
  {
    return "time time\n\
geometry_msgs/Quaternion direction\n\
uint8[20] message # 20 byte payload\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
";
  }

  static const char* value(const ::robocup_msgs::Hear_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::robocup_msgs::Hear_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.time);
      stream.next(m.direction);
      stream.next(m.message);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Hear_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::robocup_msgs::Hear_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::robocup_msgs::Hear_<ContainerAllocator>& v)
  {
    s << indent << "time: ";
    Printer<ros::Time>::stream(s, indent + "  ", v.time);
    s << indent << "direction: ";
    s << std::endl;
    Printer< ::geometry_msgs::Quaternion_<ContainerAllocator> >::stream(s, indent + "  ", v.direction);
    s << indent << "message[]" << std::endl;
    for (size_t i = 0; i < v.message.size(); ++i)
    {
      s << indent << "  message[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.message[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // ROBOCUP_MSGS_MESSAGE_HEAR_H
